"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var TokenType_1 = __importDefault(require("../Lexer/TokenType"));
var FiniteAutomaton = /** @class */ (function () {
    function FiniteAutomaton() {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
        var _this = this;
        this.initialState = 1;
        this.leftBraceState = 2;
        this.startTextState = 3;
        this.endTextState = 4;
        this.startTagState = 5;
        this.propertyState = 6;
        this.colonState = 7;
        this.startValueState = 8;
        this.endValueState = 9;
        this.endTagState = 10;
        this.rightBraceState = 11;
        this.automatonMap = {
            1: (_a = {},
                _a[TokenType_1.default.WHITESPACE] = 1,
                _a[TokenType_1.default.LEFT_BRACE] = 2,
                _a),
            2: (_b = {},
                _b[TokenType_1.default.WHITESPACE] = 2,
                _b[TokenType_1.default.BACKTICK] = 3,
                _b),
            3: (_c = {},
                _c[TokenType_1.default.TEXT] = 3,
                _c[TokenType_1.default.WHITESPACE] = 3,
                _c[TokenType_1.default.LEFT_BRACE] = 3,
                _c[TokenType_1.default.RIGHT_BRACE] = 3,
                _c[TokenType_1.default.START_TAG] = 3,
                _c[TokenType_1.default.END_TAG] = 3,
                _c[TokenType_1.default.COLON] = 3,
                _c[TokenType_1.default.PIPE] = 3,
                _c[TokenType_1.default.SEMICOLON] = 3,
                _c[TokenType_1.default.BACKTICK] = 4,
                _c),
            4: (_d = {},
                _d[TokenType_1.default.WHITESPACE] = 4,
                _d[TokenType_1.default.START_TAG] = 5,
                _d),
            5: (_e = {},
                _e[TokenType_1.default.WHITESPACE] = 5,
                _e[TokenType_1.default.TEXT] = 6,
                _e),
            6: (_f = {},
                _f[TokenType_1.default.WHITESPACE] = 6,
                _f[TokenType_1.default.COLON] = 7,
                _f),
            7: (_g = {},
                _g[TokenType_1.default.WHITESPACE] = 7,
                _g[TokenType_1.default.BACKTICK] = 8,
                _g[TokenType_1.default.TEXT] = 9,
                _g),
            8: (_h = {},
                _h[TokenType_1.default.TEXT] = 8,
                _h[TokenType_1.default.WHITESPACE] = 8,
                _h[TokenType_1.default.LEFT_BRACE] = 8,
                _h[TokenType_1.default.RIGHT_BRACE] = 8,
                _h[TokenType_1.default.START_TAG] = 8,
                _h[TokenType_1.default.END_TAG] = 8,
                _h[TokenType_1.default.COLON] = 8,
                _h[TokenType_1.default.PIPE] = 8,
                _h[TokenType_1.default.SEMICOLON] = 8,
                _h[TokenType_1.default.BACKTICK] = 9,
                _h),
            9: (_j = {},
                _j[TokenType_1.default.WHITESPACE] = 9,
                _j[TokenType_1.default.PIPE] = 7,
                _j[TokenType_1.default.SEMICOLON] = 5,
                _j[TokenType_1.default.END_TAG] = 10,
                _j),
            10: (_k = {},
                _k[TokenType_1.default.WHITESPACE] = 10,
                _k[TokenType_1.default.RIGHT_BRACE] = 11,
                _k),
        };
        this.currentState = 1;
        this.transit = function (token) {
            var innerMap = _this.automatonMap[_this.currentState];
            var state = innerMap ? innerMap[token.tokenType] : _this.initialState;
            // console.log('FOR TOKEN::::', JSON.stringify(token), ' STATE-TRANSITION:::: ', this.currentState, ' =>> ', state, ' isUndefined ? ', !state, ' default: ', state || this.initialState ) ;
            _this.currentState = state || _this.initialState;
            if (_this.currentState === _this.initialState) {
                var innerMap_1 = _this.automatonMap[_this.currentState];
                var val = innerMap_1 ? innerMap_1[token.tokenType] : _this.initialState;
                _this.currentState = val || _this.initialState;
            }
            return _this.currentState;
        };
    }
    return FiniteAutomaton;
}());
exports.default = FiniteAutomaton;
//# sourceMappingURL=FiniteAutomaton.js.map